Draft Circle: Difference between revisions

From FreeCAD Documentation
No edit summary
m (png to svg)
(62 intermediate revisions by 6 users not shown)
Line 1: Line 1:
<languages/>
{{GuiCommand|Name=Draft_Circle|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]|MenuLocation=Draft -> Circle|Shortcut=C I|SeeAlso=[[Draft Arc]]}}
<translate>
<!--T:18-->
{{Docnav|[[Draft_Fillet|Fillet]]|[[Draft_Arc|Arc]]|[[Draft_Module|Draft]]|IconL=Draft_Fillet.svg |IconC=Workbench_Draft.svg|IconR=Draft_Arc.svg}}


<!--T:1-->
==Description==
{{GuiCommand
|Name=Draft Circle
|MenuLocation=Draft → Circle
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|Shortcut={{KEY|C}} {{KEY|I}}
|SeeAlso=[[Draft Arc|Draft Arc]], [[Draft Ellipse|Draft Ellipse]]<br/>[[Macro_CirclePlus|Macro CirclePlus]]
|Version=0.7
}}


==Description== <!--T:21-->
The Circle tool creates a circle in the current [[Draft Workingplane|work plane]] by entering two points, the center and the radius, or by picking tangents, or any combination of those. It takes the [[Draft Linestyle|linewidth and color]] previously set on the Tasks tab. This tool works the same way as the [[Draft Arc]] tool, except that it stops after entering the radius.


<!--T:2-->
The Circle tool creates a circle in the current [[Draft SelectPlane|work plane]] by entering two points, the center and the radius, or by picking tangents, or any combination of those. It uses the [[Draft Linestyle|Draft Linestyle]] set on the [[Draft Tray|Draft Tray]].

<!--T:11-->
This tool works the same way as the [[Draft Arc|Draft Arc]] tool, except that it creates a full circumference. To draw an ellipse use [[Draft Ellipse|Draft Ellipse]].

</translate>
[[Image:Draft_Circle_example.jpg|400px]]
[[Image:Draft_Circle_example.jpg|400px]]
<translate>
<!--T:3-->
{{Caption|Circle defined by two points}}


==Usage== <!--T:22-->
==How to use==


<!--T:4-->
# Press the {{KEY|[[Image:Draft Circle.png|16px]] [[Draft Circle]]}} button, or press {{KEY|C}} then {{KEY|I}} keys
# Press the {{Button|[[Image:Draft_Circle.svg|16px]] [[Draft Circle|Draft Circle]]}} button, or press {{KEY|C}} then {{KEY|I}} keys.
# Click a first point on the 3D view, or type a [[Draft_Coordinates|coordinate]]
# Click a first point on the 3D view, or type a [[Draft_Coordinates|coordinate]] and press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button.
# Click a second point on the 3D view, or enter a radius value.
# Click a second point on the 3D view, or enter a radius value.


<!--T:12-->
==Options==
The circle can be edited by double clicking on the element in the tree view, or by pressing the {{Button|[[Image:Draft Edit.svg|16px]] [[Draft Edit|Draft Edit]]}} button. Then you can move the center and radius points to a new position.

<!--T:13-->
The circle can be turned into an arc after creation, by setting its first angle and last angle properties to different values.

==Options== <!--T:5-->
* The primary use of the circle tool is by picking two points, the centre and a point on the circumference.
** By pressing {{KEY|Alt}}, you can select a tangent instead of picking a point. You can therefore construct several types of circles by selecting one, two or three tangents.
* To enter coordinates manually, simply enter the numbers, then press {{KEY|Enter}} between each X, Y and Z component. You can press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button when you have entered the desired values to insert the point.
* Press {{KEY|T}} or click the checkbox to toggle ''continue'' mode. If continue mode is on, the Circle tool will restart after you finish the circle, allowing you to draw another one without pressing the tool button again.
* Press {{KEY|L}} or click the checkbox to toggle ''filled'' mode. If filled mode is on, the circle will create a filled face ({{PropertyData|Make Face}} {{TRUE}}); if not, the circle will not make a face ({{PropertyData|Make Face}} {{FALSE}}).
* Hold {{KEY|Ctrl}} while drawing to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* Hold {{KEY|Shift}} while drawing to [[Draft_Constrain|constrain]] your second point horizontally or vertically in relation to the first one.
* Press {{KEY|Esc}} or the {{Button|Close}} button to abort the current command.

==Properties== <!--T:6-->
A Circle object shares all properties from a [[Draft Arc|Draft Arc]], but some properties only make sense for the circle.

===Data=== <!--T:14-->
* {{PropertyData|First Angle}}: specifies the starting angle of the circle; normally 0&#176;.
* {{PropertyData|Last Angle}}: specifies the ending angle of the circle; normally 0&#176;.
* {{PropertyData|Radius}}: specifies the radius of the circle.
* {{PropertyData|Make Face}}: specifies if the Circle makes a face or not. If it is {{TRUE}} a face is created, otherwise only the circumference is considered part of the object. This property only works if the shape is a full circumference.
:For it to be a full circle {{PropertyData|First Angle}} and {{PropertyData|Last Angle}} should have the same value; otherwise, a [[Draft Arc|Draft Arc]] is displayed. The values 0&#176; and 360&#176; aren't considered the same, so if these two values are used, the circle will not form a face.

===View=== <!--T:15-->
* {{PropertyView|Pattern}}: specifies a [[Draft Pattern|Draft Pattern]] with which to fill the face of the circle. This property only works if {{PropertyData|Make Face}} is {{TRUE}}, and if {{PropertyView|Display Mode}} is "Flat Lines".
* {{PropertyView|Pattern Size}}: specifies the size of the [[Draft Pattern|Draft Pattern]].

==Scripting== <!--T:7-->
{{Emphasis|See also:}} [[Draft API|Draft API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].

<!--T:16-->
The Circle tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:

</translate>
{{Code|code=
Circle = makeCircle(radius, placement=None, face=None, startangle=None, endangle=None, support=None)
Circle = makeCircle(Part.Edge, placement=None, face=None, startangle=None, endangle=None, support=None)
}}
<translate>


<!--T:8-->
* The primary use of the circle tool is by picking two points, the centre and a point on the circumference, defining the radius.
* Creates a {{incode|Circle}} object with given {{incode|radius}} in millimeters.
* By pressing {{KEY|ALT}}, you can select a tangent instead of picking a point. You can therefore construct several types of circles by selecting one, two or three tangents.
** {{incode|radius}} can also be a {{incode|Part.Edge}}, whose {{incode|Curve}} attribute must be a {{incode|Part.Circle}}.
* To enter coordinates manually, simply enter the numbers, then press {{KEY|ENTER}} between each X, Y and Z component.
* If a {{incode|placement}} is given, it is used; otherwise the shape is created at the origin.
* Press {{KEY|T}} or click the checkbox to check/uncheck the {{KEY|'''Continue'''}} button. If continue mode is on, the Circle tool will restart after you give the second point, allowing you to draw another circle without pressing the Circle button again.
* If {{incode|face}} is {{incode|True}}, the circle will make a face, that is, it will appear filled.
* Press {{KEY|CTRL}} while drawing to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* If {{incode|startangle}} and {{incode|endangle}} are given in degrees, and have different values, they are used and the object appears as a [[Draft Arc|Draft Arc]].
* Press {{KEY|SHIFT}} while drawing to [[Draft_Constrain|constrain]] your second point horizontally or vertically in relation to the first one.
* Press {{KEY|I}} or the {{KEY|'''Filled'''}} button to have the circle to appear as a face after it has been closed. This simply sets the View->Property of the Circle to "Flat lines" or "Wireframe", so it can easily be changed later.
* Press {{KEY|ESC}} or the {{KEY|'''Cancel'''}} button to abort the current Line command.
* The circle can be turned into an arc after creation, by setting its first angle and last angle properties to different values.


<!--T:9-->
==Properties==
Example:
</translate>
{{Code|code=
import FreeCAD, Draft


Circle1 = Draft.makeCircle(200)
* {{PropertyData|Radius}}: The radius of the circle


ZAxis = FreeCAD.Vector(0, 0, 1)
==Scripting==
p2 = FreeCAD.Vector(1000, 1000, 0)
place2 = FreeCAD.Placement(p2, FreeCAD.Rotation(ZAxis, 0))
Circle2 = Draft.makeCircle(500, placement=place2)


p3 = FreeCAD.Vector(-1000, -1000, 0)
The Circle tool can by used in [[macros]] and from the python console the following way:
place3 = FreeCAD.Placement(p3, FreeCAD.Rotation(ZAxis, 0))
Circle3 = Draft.makeCircle(750, placement=place3)
}}
<translate>


<!--T:17-->
import Draft
{{Docnav|[[Draft_Fillet|Fillet]]|[[Draft_Arc|Arc]]|[[Draft_Module|Draft]]|IconL=Draft_Fillet.svg |IconC=Workbench_Draft.svg|IconR=Draft_Arc.svg}}
myCircle = Draft.makeCircle(2)


</translate>
{{languages | {{es|Draft Circle/es}} {{fr|Draft Circle/fr}} {{it|Draft Circle/it}} {{se|Draft Circle/se}} }}
{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{clear}}

Revision as of 04:30, 22 February 2020

Draft Circle

Menu location
Draft → Circle
Workbenches
Draft, Arch
Default shortcut
C I
Introduced in version
0.7
See also
Draft Arc, Draft Ellipse
Macro CirclePlus

Description

The Circle tool creates a circle in the current work plane by entering two points, the center and the radius, or by picking tangents, or any combination of those. It uses the Draft Linestyle set on the Draft Tray.

This tool works the same way as the Draft Arc tool, except that it creates a full circumference. To draw an ellipse use Draft Ellipse.

Circle defined by two points

Usage

  1. Press the Draft Circle button, or press C then I keys.
  2. Click a first point on the 3D view, or type a coordinate and press the add point button.
  3. Click a second point on the 3D view, or enter a radius value.

The circle can be edited by double clicking on the element in the tree view, or by pressing the Draft Edit button. Then you can move the center and radius points to a new position.

The circle can be turned into an arc after creation, by setting its first angle and last angle properties to different values.

Options

  • The primary use of the circle tool is by picking two points, the centre and a point on the circumference.
    • By pressing Alt, you can select a tangent instead of picking a point. You can therefore construct several types of circles by selecting one, two or three tangents.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component. You can press the add point button when you have entered the desired values to insert the point.
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the Circle tool will restart after you finish the circle, allowing you to draw another one without pressing the tool button again.
  • Press L or click the checkbox to toggle filled mode. If filled mode is on, the circle will create a filled face (DataMake Face true); if not, the circle will not make a face (DataMake Face false).
  • Hold Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Hold Shift while drawing to constrain your second point horizontally or vertically in relation to the first one.
  • Press Esc or the Close button to abort the current command.

Properties

A Circle object shares all properties from a Draft Arc, but some properties only make sense for the circle.

Data

  • DataFirst Angle: specifies the starting angle of the circle; normally 0°.
  • DataLast Angle: specifies the ending angle of the circle; normally 0°.
  • DataRadius: specifies the radius of the circle.
  • DataMake Face: specifies if the Circle makes a face or not. If it is true a face is created, otherwise only the circumference is considered part of the object. This property only works if the shape is a full circumference.
For it to be a full circle DataFirst Angle and DataLast Angle should have the same value; otherwise, a Draft Arc is displayed. The values 0° and 360° aren't considered the same, so if these two values are used, the circle will not form a face.

View

  • ViewPattern: specifies a Draft Pattern with which to fill the face of the circle. This property only works if DataMake Face is true, and if ViewDisplay Mode is "Flat Lines".
  • ViewPattern Size: specifies the size of the Draft Pattern.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The Circle tool can be used in macros and from the Python console by using the following function:

Circle = makeCircle(radius, placement=None, face=None, startangle=None, endangle=None, support=None)
Circle = makeCircle(Part.Edge, placement=None, face=None, startangle=None, endangle=None, support=None)
  • Creates a Circle object with given radius in millimeters.
    • radius can also be a Part.Edge, whose Curve attribute must be a Part.Circle.
  • If a placement is given, it is used; otherwise the shape is created at the origin.
  • If face is True, the circle will make a face, that is, it will appear filled.
  • If startangle and endangle are given in degrees, and have different values, they are used and the object appears as a Draft Arc.

Example:

import FreeCAD, Draft

Circle1 = Draft.makeCircle(200)

ZAxis = FreeCAD.Vector(0, 0, 1)
p2 = FreeCAD.Vector(1000, 1000, 0)
place2 = FreeCAD.Placement(p2, FreeCAD.Rotation(ZAxis, 0))
Circle2 = Draft.makeCircle(500, placement=place2)

p3 = FreeCAD.Vector(-1000, -1000, 0)
place3 = FreeCAD.Placement(p3, FreeCAD.Rotation(ZAxis, 0))
Circle3 = Draft.makeCircle(750, placement=place3)